use "JHR_data_2", clear


set more off

#delimit;
gen a=string(ua);
gen b=string(z);
gen c=string(Y);
gen d=string(sid);
gen e="Y";
gen f="z";

*tab ua; tab z; tab Y;

gen fx=a+b+c;
gen uazY=a+f+b+e+c;
gen sid2=d+e+c;
gen dg =1 if dzg >=0; replace dg =0 if dzg <0;
gen dga=1 if dzag>=0; replace dga=0 if dzag<0;
gen dk =1 if dzk >=0; replace dk =0 if dzk <0;
gen dka=1 if dzak>=0; replace dka=0 if dzak<0;
gen dgdzg=dg*dzg;

gen dzg2 =dzg *dzg ;
gen dzag2=dzag*dzag;
gen dzag_dga=dzag*dga;



#delimit;

/* define sample restrictions so that regression w/out controls have the same sample size as w/ controls */;




gen earlier=0;
replace earlier=1 if cohort==2005 & year==1989 & month>=10 &  month<=12;
replace earlier=1 if cohort==2006 & year==1990 & month>=10 &  month<=12;
gen later=0;
replace later=1 if cohort==2005 & year==1991 & month>=1 &  month<=3;
replace later=1 if cohort==2006 & year==1992 & month>=1 &  month<=3;
gen sample2=1 if cohort==2005 & birthmonth>=-8 &  birthmonth<=9;
replace sample2=1 if cohort==2006 & birthmonth>=4 &  birthmonth<=21;



forvalues bmonth=1/12 {;
	quietly gen byte bmonth_`bmonth'=0 if month!=.;
	quietly replace bmonth_`bmonth'=1 if month==`bmonth';
};

gen month2=month*month/10;

*sort highschool cohort county;
*by  highschool cohort county: egen school_grade=mean(grade);

gen school_grade=agus;

global restrict1 " bmonth!=.";
drop after;
gen after=(birthmonth>=0);


egen bct_z05 = std(bct) if cohort==2005;
egen bct_z06 = std(bct) if cohort==2006;
gen bct_z= bct_z05;
replace bct_z= bct_z06 if bct_z==.;

egen bcg_z05 = std(bcg) if cohort==2005;
egen bcg_z06 = std(bcg) if cohort==2006;
gen bcg_z= bcg_z05;
replace bcg_z= bcg_z06 if bcg_z==.;

#delimit;
egen bcgr_z05 = std(bcgr) if cohort==2005;
egen bcgr_z06 = std(bcgr) if cohort==2006;
gen bcgr_z= bcgr_z05;
replace bcgr_z= bcgr_z06 if bcgr_z==.;


replace cohort=cohort-2005;


gen before = 0 if bmonth~=.;
replace before = 1 if bmonth>=0 & bmonth<=6;
gen unwanted = ( birthmonth<0) if birthmonth~=.;
gen wanted=!unwanted if unwanted!=.;

gen dga_before=dga*before;

gen dzag_before=dzag*before;
gen dzag_dga_before=dzag_dga*before;

#delimit;
gen dga_cohort=dga*cohort;
gen dzag_cohort=dzag*cohort;
gen dzag_dga_cohort=dzag_dga*cohort;

gen dga_month=dga*month;
gen dzag_month=dzag*month;
gen dzag_dga_month=dzag_dga*month;

gen dga_month2=dga*month2;
gen dzag_month2=dzag*month2;
gen dzag_dga_month2=dzag_dga*month2;

gen dga_wanted=dga*wanted;
gen dzag_wanted=dzag*wanted;
gen dzag_dga_wanted=dzag_dga*wanted;

forvalues bmonth=1/12 {;
	quietly gen byte dga_bmonth_`bmonth'=0 if month!=. & dga!=.;
	quietly replace dga_bmonth_`bmonth'=dga if month==`bmonth';
	
	quietly gen byte dzag_bmonth_`bmonth'=0 if month!=. & dzag!=.;
	quietly replace dzag_bmonth_`bmonth'=dzag  if month==`bmonth';
	
	quietly gen byte dzag_dga_bmonth_`bmonth'=0 if month!=. & dzag_dga!=.;
	quietly replace dzag_dga_bmonth_`bmonth'=dzag_dga if month==`bmonth';
	

};



gen nonpoor=1-poor;
gen dga_nonpoor=dga*nonpoor;
gen dzag_nonpoor=dzag*nonpoor;
gen dzag_dga_nonpoor=dzag_dga*nonpoor;

*Sample restriction;
keep if sample==1 & bcg_z!=.;

*Final setup;

*Create an variable indicating born in second half of year ("after" July). Note that this is different than the "after" variable defined above, which is based on both month and year of birth. So, drop existing after variable first;
drop after;
gen after = 1-before;
tab cohort after if wanted==0;
tab birthmonth wanted;

#delimit cr

	gen access = after*cohort
	tab access wanted

	sort sid year z
	order sid year z
	
	*Check that zga indicates the transition score threshold a given observation was normalized against
	count if zga!=grade-dzag

	*Conceive of a "market" as a town year combo
	egen townid = group(ua)
	egen schoolid = group(townid us)
		
	gen tpj = zga
	count if grade!=tpj+dzag
		
	*The school identifiers z are not defined in increasing order of transition score threshold, so geenrate a new variable "j" that is (note, these j's are only meaningful within market if ordering of thresholds changes between the cohorts)
	sort townid year tpj z sid
	gen temp = (z[_n]!=z[_n-1])
	bysort townid year: replace temp = 1 if _n==1
	by townid year: gen j = sum(temp)
	drop temp
		
	sort townid year j sid
	gen temp = _n
	sort towni	d year tpj sid
		count if temp!=_n
		drop temp
		
	sort townid year j sid 
	egen tpjid = group(townid j year)
	
	tab after cohort
			
qui save "ready_to_reweight.dta", replace
